unit Unit1;

//   TAG:  CXY   (c*10000 + X*100 + Y)
//
//     C = tipo de Casilla
//   X,Y = Posicin de la Casilla

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ImgList, jpeg, ExtCtrls, ScktComp;

{ ***************************************************************** }

Const maxX = 10;
      maxY = 10;

      Nada = 0;
      Barco = 1;
      Tocado = 2;
      Agua = 3;

      CuantosBarcos : Array[1..4] of integer = ( 4, 3, 2, 1 );  // 4 de un cuadrito, 3 de dos...

{ ***************************************************************** }


type
  Cuadricula = array[1..maxX, 1..maxY] of TSpeedButton;

  TForm1 = class(TForm)
    ImageFondo: TImage;
    btnNuevaPartida: TButton;
    btnListo: TButton;
    btnConectar: TButton;
    Client: TClientSocket;
    Server: TServerSocket;
    imgBarco: TImage;
    imgAgua: TImage;
    imgTocado: TImage;
    imgNada: TImage;
    TimerParaDecirHola: TTimer;
    EditTurno: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    btnMensaje: TButton;
    Label1: TLabel;
    editMensaje: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnNuevaPartidaClick(Sender: TObject);
    procedure btnListoClick(Sender: TObject);
    procedure btnConectarClick(Sender: TObject);
    procedure TimerParaDecirHolaTimer(Sender: TObject);
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure btnMensajeClick(Sender: TObject);
  private
    { Private declarations }
    procedure CrearCuadricula(var Cuadric : Cuadricula; inicial: integer; initX, initY : integer; cuala : char);
    procedure SetCasilla(var Cuadric : Cuadricula; X,Y : integer; Color : integer );
    procedure MiCasillaClick(Sender: TObject);
    procedure SuCasillaClick(Sender: TObject);
    function _X ( Casilla : TSpeedButton ) : integer;
    function _Y ( Casilla : TSpeedButton ) : integer;
    function _Tipo ( Casilla : TSpeedButton ) : integer; overload;
    function _Tipo ( Cuad : Cuadricula; X,Y : integer ) : integer; overload;
    procedure SendCommand(Comando: string);
    procedure MeDisparan(lin : string);
    procedure QuePasoConDisparo(lin: string);
    function BarcoHundido(X, Y: integer): boolean;
    procedure BordeaBarcoConAgua(Cuad: cuadricula; X, Y: integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  BarcosMios, BarcosSuyos : Cuadricula;

  ColocandoBarcos : boolean;
  YaHeDichoHola : boolean;
  MiTurno : boolean;

  CasillasTocadasSuyas,
  CasillasTocadasMias : integer;

  LastShotX, LastShotY : integer;

implementation

{$R *.DFM}

{ ***************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
begin

  Self.Show;
  Self.Refresh;

  CrearCuadricula ( BarcosMios, Nada, 50,70,'M' );
  CrearCuadricula ( BarcosSuyos, Nada, 300,70,'S' );

  MiTurno := false;

  btnNuevaPartida.enabled := false;
  EditTurno.Text := '';
  EditTurno.Color := $AAAAAA;

  ColocandoBarcos := true;
  btnListo.enabled := true;

  CasillasTocadasSuyas := 0;
  CasillasTocadasMias := 0;

  LastShotX := 0;
  LastShotY := 0;

  // Necesito que sea bloqueante, para que al levantar
  //  el Cliente me pispe de si hay un servidor.
  Client.Socket.ClientType := ctBlocking;

  // Comprobamos que no hay otro Server levantado en
  //   esta misma mquina, escuchando en el mismo puerto.
  try
    Server.Active := true;
  except
  end;

end;


{ ***************************************************************** }

procedure TForm1.CrearCuadricula(var Cuadric : Cuadricula; inicial: integer; initX, initY : integer; cuala : char);
var x,y : integer;
begin

  for x := 1 to maxX do
    for y := 1 to maxY do begin
      Cuadric[x,y] := TSpeedButton.Create(Self);
      Cuadric[x,y].Parent := Self;
      Cuadric[x,y].Width := 18;
      Cuadric[x,y].Height := 18;
      Cuadric[x,y].Left := initX+(18*(x-1));
      Cuadric[x,y].Top := initY+(18*(y-1));
      Cuadric[x,y].Tag := inicial*10000+X*100+Y;
      Cuadric[x,y].Spacing := 0;
      Cuadric[x,y].NumGlyphs := 1;
      Cuadric[x,y].Visible := true;

      if cuala='M' then
        Cuadric[x,y].OnClick := MiCasillaClick
      else
        Cuadric[x,y].OnClick := SuCasillaClick;

    end;

end;


{ ***************************************************************** }

procedure TForm1.SetCasilla(var Cuadric: Cuadricula; X, Y, Color: integer);
begin

  if (x<1) or (x>maxX) or (y<1) or (y>maxY) then exit;
  
  Cuadric[x,y].tag:=(Cuadric[x,y].tag mod 10000) + (Color*10000);
  Cuadric[x,y].NumGlyphs := 1;
  Case color of
    Nada   : Cuadric[x,y].Glyph := imgNada.Picture.Bitmap;
    Barco  : Cuadric[x,y].Glyph := imgBarco.Picture.Bitmap;
    Tocado : Cuadric[x,y].Glyph := imgTocado.Picture.Bitmap;
    Agua   : Cuadric[x,y].Glyph := imgAgua.Picture.Bitmap;
  end;
  Cuadric[x,y].Repaint;

end;


{ ***************************************************************** }

procedure TForm1.MiCasillaClick(Sender: TObject);
var btn : TSpeedButton;
    X,Y,Tipo : integer;
begin


  if ColocandoBarcos then begin

    btn := TSpeedButton(Sender);
    X := _X(btn);
    Y := _Y(btn);
    Tipo := _Tipo(btn);

    if (Tipo = Barco) then
      SetCasilla(BarcosMios, X,Y , Nada )
    else
      SetCasilla(BarcosMios, X,Y , Barco );

  end;

end;


{ ***************************************************************** }

procedure TForm1.SuCasillaClick(Sender: TObject);
var btn : TSpeedButton;
    cad : string;
    X,Y : integer;
begin

  if MiTurno then begin
    btn := TSpeedButton(Sender);

    X := _X(btn);
    Y := _Y(btn);
    if _Tipo(BarcosSuyos[x,y])<>Nada then exit;

    if (btn.tag mod 10000) < 100 then
      cad := ('FIRE 00'+IntToStr(btn.tag mod 10000))
    else if (btn.tag mod 10000) < 1000 then 
      cad := ('FIRE 0'+IntToStr(btn.tag mod 10000))
    else
      cad := ('FIRE '+IntToStr(btn.tag mod 10000));

    SendCommand(cad);
    MiTurno := false;
    EditTurno.Text := 'Turno Contrario';
    EditTurno.Color := $0000DD;
  end else begin
    MessageBox(self.Handle,PChar('No es su turno!!!'),PChar('Error!'),MB_OK);
    exit;
  end;

end;


{ ***************************************************************** }

procedure TForm1.btnNuevaPartidaClick(Sender: TObject);
var x,y : integer;
begin

  btnNuevaPartida.enabled := false;
  EditTurno.Text := '';
  EditTurno.Color := $AAAAAA;

  for x := 1 to maxX do
    for y := 1 to maxY do begin
      SetCasilla(BarcosMios,x,y,Nada);
      SetCasilla(BarcosSuyos,x,y,Nada);
      BarcosMios[x,y].flat := false;
    end;

  ColocandoBarcos := true;
  btnListo.enabled := true;

  CasillasTocadasSuyas := 0;
  CasillasTocadasMias := 0;

  LastShotX := 0;
  LastShotY := 0;

end;


{ ***************************************************************** }

function TForm1._X(Casilla: TSpeedButton) : integer;
begin
  if Casilla<>nil then
    result := ( (casilla.tag div 100) mod 100)
  else
    result := 0;  // :-?
end;

function TForm1._Y(Casilla: TSpeedButton) : integer;
begin
  if Casilla<>nil then
    result := (casilla.tag mod 100)
  else
    result := 0;  // :-?
end;

function TForm1._Tipo(Casilla: TSpeedButton) : integer;
begin
  result := (casilla.tag div 10000)
end;

function TForm1._Tipo ( Cuad : Cuadricula; X,Y : integer ) : integer;
var kk : integer;
begin
  if (X>0) and (X<=maxX) and (Y>0) and (Y<=maxY) then begin
    kk := (Cuad[X,Y].tag div 10000);
    result := kk;
  end else
    result := agua;
end;


{ ***************************************************************** }

procedure TForm1.btnListoClick(Sender: TObject);
var NumCasillasTotal, NumCasillasEsperado : integer;
    x , y , numBarcosDeUno : integer;
begin

  // Vamos a ver si ha puesto todos los barcos...
  NumCasillasTotal := 0;
  NumCasillasEsperado := 0;
  for x := 1 to 4 do
    inc(NumCasillasEsperado,CuantosBarcos[x]*x);

  for x := 1 to maxX do
    for y := 1 to maxY do
      if _Tipo(BarcosMios[x,y])=Barco then inc(NumCasillasTotal);

  if NumCasillasTotal<NumCasillasEsperado then begin
    MessageBox(self.Handle,PChar('Ha puesto barcos de menos'),PChar('Error!'),MB_OK);
    exit;
  end else if NumCasillasTotal>NumCasillasEsperado then begin
    MessageBox(self.Handle,PChar('Ha puesto barcos de ms'),PChar('Error!'),MB_OK);
    exit;
  end;

  // Vamos a comprobar si ha cumplido la regla de las diagonales.
  for x := 2 to maxX-1 do
    for y := 2 to maxY-1 do
      if _Tipo(BarcosMios[x,y])=Barco then
        if (_Tipo(BarcosMios[x-1,y-1])=Barco) or
           (_Tipo(BarcosMios[x+1,y-1])=Barco) or
           (_Tipo(BarcosMios[x-1,y+1])=Barco) or
           (_Tipo(BarcosMios[x+1,y+1])=Barco) then begin
          MessageBox(self.Handle,PChar('Ha puesto casillas en diagonal'),PChar('Error!'),MB_OK);
          exit;
        end;

  // Vamos a ver si ha puesto 4 barcos de 1...
  NumBarcosDeUno := 0;
  for x := 1 to maxX do
    for y := 1 to maxY do begin
      if (_Tipo(BarcosMios,x  ,y  )=Barco) then
        if (_Tipo(BarcosMios,x-1,y-1) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x  ,y-1) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x+1,y-1) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x-1,y  ) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x+1,y  ) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x-1,y+1) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x  ,y+1) in [Agua,Nada]) and
           (_Tipo(BarcosMios,x+1,y+1) in [Agua,Nada]) then inc(NumBarcosDeUno);
    end;
  if (NumBarcosDeUno<>4) then begin
    MessageBox(self.Handle,PChar('Debe colocar:'+#13+#13+'1 Barco de 4'+#13+'2 Barcos de 3'+#13+'3 Barcos de 2'+#13+'4 Barcos de 1'),PChar('Error!'),MB_OK);
    exit;
  end;


  // Listo, podemos conectarnos. :-)
  btnListo.enabled := false;
  btnConectar.Enabled := true;
  ColocandoBarcos := false;

end;


{ ***************************************************************** }

procedure TForm1.btnConectarClick(Sender: TObject);
var IP_Remoto : string;
    HayRemoto : boolean;
begin

  if btnConectar.Caption='&Conectar...' then begin
    if (not InputQuery('Conectar con...','Escriba el IP contra el que desea conectarse:',IP_Remoto)) or (IP_Remoto='') then exit;
    HayRemoto := true;
    Client.Address := IP_Remoto;
    btnConectar.Caption := '&Conectando...';
    try
      Client.Active := true;
    except
      Client.Socket.Close;
      Client.Close;
      Client.Active := false;
      MessageBox(self.Handle,PChar('No se encuentra el Juego en la mquina remota'),PChar('Error!'),MB_OK);
      btnConectar.Caption := '&Conectar...';
      HayRemoto := false;
    end;
    if HayRemoto then begin
      TimerParaDecirHola.Interval := 10;
      YaHeDichoHola := false;
    end;  
  end else begin
    Sendcommand('CIAO');
  end;

end;


{ ***************************************************************** }

procedure TForm1.SendCommand ( Comando : string );
begin
  if Client.Active then begin
    Client.Socket.SendText (Comando);
    Edit1.Text := 'CLI2SER '+Comando;
  end else begin
    Server.Socket.Connections[0].SendText(Comando);;
    Edit1.Text := 'SER2CLI '+Comando;
  end
end;


{ ***************************************************************** }

procedure TForm1.TimerParaDecirHolaTimer(Sender: TObject);
begin

  if not YaHeDichoHola then begin
    TimerParaDecirHola.Interval := 2000; // PING TimeOut
    YaHeDichoHola := true;
    SendCommand('HOLA');
  end else begin
    TimerParaDecirHola.Interval := 0;
    Client.Socket.Close;
    Client.Close;
    Client.Active := false;
    MessageBox(self.Handle,PChar('* SERVER TIMEOUT *'),PChar('Error!'),MB_OK);
    btnConectar.Caption := '&Conectar...';
  end;

end;


{ ***************************************************************** }

procedure TForm1.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
var lin : string;
begin

  lin := Socket.ReceiveText;
  Edit2.text := lin;

  if lin='HOLA' then begin

    // Nos piden conectarnos

    if not ColocandoBarcos then begin
      SendCommand('HOLA_CONNECTED');
      btnConectar.Caption := '&Desconectar';
      btnConectar.enabled := true;
      MiTurno := false;
      EditTurno.Text := 'Turno Contrario';
      EditTurno.Color := $0000DD;
      btnMensaje.enabled := true;
    end else
      SendCommand('HOLA_WAIT');


  end else if lin='HOLA_CONNECTED' then begin

    // Nos confirman la conexin.
    btnConectar.Caption := '&Desconectar';
    btnConectar.enabled := true;
    MiTurno := true;
    EditTurno.Text := 'Tu Turno';
    EditTurno.Color := $00DD00;
    TimerParaDecirHola.Interval := 0;
    btnMensaje.enabled := true;

  end else if lin='HOLA_WAIT' then begin

    MessageBox(Self.Handle, PChar('El otro jugador an est colocando sus barcos.'+#13+'Por favor, vuelva a intentarlo ms tarde'),PChar('Error!'), MB_OK);

  end else if lin='CIAO' then begin

    // Nos piden desconectarnos.
    SendCommand('CIAO_DISCONNECTED');
    if Client.Active then
      Client.Active := false
    else begin
      Server.Socket.Connections[0].Close;
      Server.Close;
      Server.Active := true;
    end;
    btnConectar.Caption := '&Conectar...';
    btnConectar.enabled := false;
    btnNuevaPartida.enabled := true;
    btnMensaje.enabled := false;
    miTurno := false;
    ColocandoBarcos := true;

  end else if lin='CIAO_DISCONNECTED' then begin

    // Nos confirman la desconexin.
    if Client.Active then
      Client.Active := false
    else begin
      Server.Socket.Connections[0].Close;
      Server.Close;
      Server.Active := true;
    end;
    btnConectar.Caption := '&Conectar...';
    btnConectar.enabled := false;
    btnNuevaPartida.enabled := true;
    btnMensaje.enabled := false;
    miTurno := false;
    ColocandoBarcos := true;

  end else if copy(lin,1,4)='FIRE' then begin

    MeDisparan(copy(lin,6,length(lin)-5));

  end else if copy(lin,1,4)='RESP' then begin

    QuePasoConDisparo(copy(lin,6,length(lin)-5));

  end else if copy(lin,1,3)='MSG' then begin

    editMensaje.Text := copy(lin,5,length(lin)-4);
    if editMensaje.Color = $AAAAAA then
       editMensaje.Color := $CCCCCC
     else
       editMensaje.Color := $AAAAAA;

  end;

end;


{ ***************************************************************** }

procedure TForm1.MeDisparan(lin : string);
var X,Y : integer;
    TaTocado : boolean;
begin

  if (LastShotX>0) and (LastShotY>0) then BarcosMios[LastShotX,LastShotY].Flat := false;

  X := StrToInt(copy(lin,1,2));
  Y := StrToInt(copy(lin,3,2));
  BarcosMios[X,Y].Flat := true;
  LastShotX := X;
  LastShotY := Y;

  if _Tipo(BarcosMios[x,y])=Barco then begin
    SetCasilla(BarcosMios,x,y,Tocado);
    SetCasilla(BarcosMios,x-1,y-1,Agua);
    SetCasilla(BarcosMios,x+1,y-1,Agua);
    SetCasilla(BarcosMios,x-1,y+1,Agua);
    SetCasilla(BarcosMios,x+1,y+1,Agua);
    TaTocado := true;
    inc(CasillasTocadasMias);

    if not BarcoHundido(x,y) then
      SendCommand('RESP 1 '+lin) // Tocado
    else begin
      SendCommand('RESP 2 '+lin); // Hundido
      BordeaBarcoConAgua(BarcosMios,X,Y);
    end;

    if CasillasTocadasMias=(1*4+2*3+3*2+4*1) then begin
      BarcosMios[LastShotX,LastShotY].Flat := false;
      MessageBox(self.Handle,PChar('HAS PERDIDO!!!'),PChar(''),MB_OK);
      EditTurno.Text := 'Fin del Juego';
      EditTurno.Color := $DDDD00;
      btnConectarClick(Self);
      exit;
    end;

  end else begin
    TaTocado := false;
    SetCasilla(BarcosMios,x,y,Agua);
    SendCommand('RESP 0 '+lin); // Agua
  end;

  if not TaTocado then begin
    MiTurno := true;
    EditTurno.Text := 'Tu Turno';
    EditTurno.Color := $00DD00;
  end;

end;


{ ***************************************************************** }

procedure TForm1.QuePasoConDisparo(lin : string);
var TaTocado, TaHundido : boolean;
    X,Y : integer;
begin

  TaHundido := copy(lin,1,1)='2';
  TaTocado := ((copy(lin,1,1)='1') or TaHundido);

  X := StrToInt(copy(lin,3,2));
  Y := StrToInt(copy(lin,5,2));

  if TaHundido then BordeaBarcoConAgua(BarcosSuyos,X,Y);

  if TaTocado then begin
    SetCasilla(BarcosSuyos,X,Y,Tocado);
    SetCasilla(BarcosSuyos,X-1,Y-1,Agua);
    SetCasilla(BarcosSuyos,X+1,Y-1,Agua);
    SetCasilla(BarcosSuyos,X-1,Y+1,Agua);
    SetCasilla(BarcosSuyos,X+1,Y+1,Agua);
    inc(CasillasTocadasSuyas);
    if CasillasTocadasSuyas=(1*4+2*3+3*2+4*1) then begin
      MessageBox(self.Handle,PChar('HAS GANADO!!!'),PChar(''),MB_OK);
      EditTurno.Text := 'Fin del Juego';
      EditTurno.Color := $DDDD00;
      MiTurno := false;
      exit;
    end;
  end else
    SetCasilla(BarcosSuyos,X,Y,Agua);

  if TaTocado then begin
    MiTurno := true;
    EditTurno.Text := 'Tu Turno';
    EditTurno.Color := $00DD00;
  end;

  if TaHundido then
    MessageBox(self.Handle,PChar('HUNDIDO'),PChar(''),MB_OK);

end;

{ ***************************************************************** }

function TForm1.BarcoHundido(X,Y : integer) : boolean;
var hundido : boolean;
    xx,yy : integer;
begin

  // Debemos encontrar, en la cadena del barco, una casilla no tocada. :)

  hundido := true;

  // Direccin IZQUIERDA.
  if (X>1) and (hundido) then begin
    XX := X-1;
    YY := Y;
    while (_Tipo(BarcosMios[XX,YY])=Tocado) and (XX>0) do dec(XX);
    if (XX>0) and (_Tipo(BarcosMios[XX,YY])=Barco) then hundido := false;
  end;

  // Direccin DERECHA.
  if (X<maxX) and (hundido) then begin
    XX := X+1;
    YY := Y;
    while (_Tipo(BarcosMios[XX,YY])=Tocado) and (XX<=maxX) do inc(XX);
    if (XX<=maxX) and (_Tipo(BarcosMios[XX,YY])=Barco) then hundido := false;
  end;

  // Direccin ARRIBA.
  if (Y>1) and (hundido) then begin
    XX := X;
    YY := Y-1;
    while (_Tipo(BarcosMios[XX,YY])=Tocado) and (YY>0) do dec(YY);
    if (YY>0) and (_Tipo(BarcosMios[XX,YY])=Barco) then hundido := false;
  end;

  // Direccin ABAJO.
  if (Y<maxY) and (hundido) then begin
    XX := X;
    YY := Y+1;
    while (_Tipo(BarcosMios[XX,YY])=Tocado) and (YY<=maxY) do inc(YY);
    if (YY<=maxY) and (_Tipo(BarcosMios[XX,YY])=Barco) then hundido := false;
  end;

  Result := hundido;

end;

{ ***************************************************************** }

procedure TForm1.BordeaBarcoConAgua(Cuad : cuadricula; X,Y : integer);
var xx,yy : integer;
begin

  if _Tipo(Cuad[X,Y])=Agua then exit;
  SetCasilla(Cuad,X-1,Y-1,Agua);
  SetCasilla(Cuad,X+1,Y-1,Agua);
  SetCasilla(Cuad,X-1,Y+1,Agua);
  SetCasilla(Cuad,X+1,Y+1,Agua);

  // Hacia la IZQUIERDA:
  if (X>1) then begin
    XX := X-1;
    YY := Y;
    while (_Tipo(Cuad[XX,YY])=Tocado) and (XX>0) do begin
      SetCasilla(Cuad,XX-1,YY-1,Agua);
      SetCasilla(Cuad,XX+1,YY-1,Agua);
      SetCasilla(Cuad,XX-1,YY+1,Agua);
      SetCasilla(Cuad,XX+1,YY+1,Agua);
      dec(XX);
    end;
    if (XX>0) then SetCasilla(Cuad,XX,YY,Agua);
  end;

  // Hacia la DERECHA:
  if (X<MaxX) then begin
    XX := X+1;
    YY := Y;
    while (_Tipo(Cuad[XX,YY])=Tocado) and (XX<=maxX) do begin
      SetCasilla(Cuad,XX-1,YY-1,Agua);
      SetCasilla(Cuad,XX+1,YY-1,Agua);
      SetCasilla(Cuad,XX-1,YY+1,Agua);
      SetCasilla(Cuad,XX+1,YY+1,Agua);
      inc(XX);
    end;
    if (XX<=maxX) then SetCasilla(Cuad,XX,YY,Agua);
  end;

  // Hacia ARRIBA:
  if (Y>1) then begin
    XX := X;
    YY := Y-1;
    while (_Tipo(Cuad[XX,YY])=Tocado) and (YY>0) do begin
      SetCasilla(Cuad,XX-1,YY-1,Agua);
      SetCasilla(Cuad,XX+1,YY-1,Agua);
      SetCasilla(Cuad,XX-1,YY+1,Agua);
      SetCasilla(Cuad,XX+1,YY+1,Agua);
      dec(YY);
    end;
    if (YY>0) then SetCasilla(Cuad,XX,YY,Agua);
  end;

  // Hacia ABAJO:
  if (Y<MaxY) then begin
    XX := X;
    YY := Y+1;
    while (_Tipo(Cuad[XX,YY])=Tocado) and (YY<=maxY) do begin
      SetCasilla(Cuad,XX-1,YY-1,Agua);
      SetCasilla(Cuad,XX+1,YY-1,Agua);
      SetCasilla(Cuad,XX-1,YY+1,Agua);
      SetCasilla(Cuad,XX+1,YY+1,Agua);
      inc(YY);
    end;
    if (YY<=maxY) then SetCasilla(Cuad,XX,YY,Agua);
  end;

end;


{ ***************************************************************** }

procedure TForm1.btnMensajeClick(Sender: TObject);
var msg : string;
begin

  if InputQuery('Enviar mensaje de texto:','Mensaje',msg) then
    SendCommand('MSG '+msg);

end;

end.

